function [Xtrain_final, Xtest_final]=DrawNearestNeighbors(X_train_sample,Y_train_sample,X_test_sample, SampleSize,kNNsampleIndices, kNearestNeighbors, distmeasure, indexinRelFeat)
%**********************************************
%*************     Rescaling      **************
%**********************************************
colmin = min(X_train_sample);
colmax=max(X_train_sample);
X_train_sample_rescale = rescale(X_train_sample ,'InputMin',colmin,'InputMax',colmax);


colmin = min(X_test_sample);
colmax=max(X_test_sample);
X_test_sample_rescale = rescale(X_test_sample ,'InputMin',colmin,'InputMax',colmax);

%************************************************
X_train_sample=X_train_sample_rescale(kNNsampleIndices(1:SampleSize),indexinRelFeat);
Xtrain_final=X_train_sample;
X_test_sample=X_test_sample_rescale(:,indexinRelFeat);
X_test_sample=X_test_sample(1,:);
Xtest_final=X_test_sample;

[n,d]=knnsearch(X_train_sample,X_test_sample,'k',kNearestNeighbors,'NSMethod','exhaustive','Distance', distmeasure);

handle1=figure;
g1=gscatter(X_train_sample(:,1), X_train_sample(:,2),Y_train_sample,'gr','do');
hold on;
line(X_train_sample(n,1),X_train_sample(n,2),'color',[0 .1 1],'marker','o',...
   'linestyle','none','markersize',10);
line(X_test_sample(:,1), X_test_sample(:,2),'marker','x','color','k',...
   'markersize',10,'linewidth',2,'linestyle','none');
legend('no default', ' default', 'euclidian', 'query point',...
 'Location','best');
xlabel('Credit Limit');
ylabel('Payment made in September');
ylim([-.05,  max(max(X_train_sample(:,2)),max(max(X_test_sample(:,2))))+0.05]);
xlim([-.05,  max(max(X_train_sample(:,1)),max(max(X_test_sample(:,1))))+0.05]);
%%
figure;
g2=gscatter(X_train_sample(:,1), X_train_sample(:,2),Y_train_sample,'gr','do');
hold on;

line(X_train_sample(n,1),X_train_sample(n,2),'color',[0 .1 1],'marker','o',...
   'linestyle','none','markersize',10);
line(X_test_sample(:,1), X_test_sample(:,2),'marker','x','color','k',...
   'markersize',10,'linewidth',2,'linestyle','none');
legend('no default', ' default', 'euclidian', 'query point',...
 'Location','best');
xlabel('Credit Limit');
ylabel('Payment made in September');
ylim([-.01,  0.04]);
xlim([-.01,  0.08]);