function newXY_train=kNN_UND(XY_train, kNNeighbors)

majority_ind=find(table2array(XY_train(:,'Default_Status'))==0);
minority_ind=find(table2array(XY_train(:,'Default_Status'))==1);
%prevalence_rate=length(minority_ind)/(length(minority_ind)+length(majority_ind));
UpsampleRate=round(length(majority_ind)/length(minority_ind))-1;

smote_data=zeros(UpsampleRate*length(minority_ind),size(XY_train,2)-1);
%Xdata_train=table2array(XY_train(:,1:end));
XYdata_train=table2array(XY_train);

%------------------------------------------------------------------------

t=1;

delete=zeros(1,length(majority_ind));

for i=1:length(majority_ind)
    
    search_data=XYdata_train(:,1:end-1);
    
    search_data(majority_ind(i),:)=[];
    
    neighbor_index=knnsearch(search_data, XYdata_train(majority_ind(i),1:end-1),'K',kNNeighbors);
    
    %count number of neighbors from class 1 
   
    count=sum(XYdata_train(neighbor_index,end)==1);
    
    delete(i)=1*(count>=t)+0*(count<t);

end

under_sample=XYdata_train;

under_sample(majority_ind(delete==1),:)=[];

%X_train=under_sample(:,1:23);

%Y_train=under_sample(:,24);


%------------------------------------------------------------------------

%sampling_data=[smote_data,ones(UpsampleRate*length(minority_ind),1)];

%sampling_data(:,[2:4,6:11])=round(sampling_data(:,[2:4,6:11]));


newXY_train=array2table(under_sample);
newXY_train.Properties.VariableNames=XY_train.Properties.VariableNames;


